Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -7346,57 +7355,54 @@
        ENDIF
     ENDIF
- 
+
  END SUBROUTINE salsa_tendency_ij
- 
-! 
+!
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculate the tendencies for aerosol number and mass concentrations. 
+!> Calculate the tendencies for aerosol number and mass concentrations.
 !> Vector-optimized.
-!------------------------------------------------------------------------------! 
- SUBROUTINE salsa_tendency( id, rs_p, rs, trs_m, b, c, rs_init )
-    
-    USE advec_ws,                                                              &
-        ONLY:  advec_s_ws 
-    USE advec_s_pw_mod,                                                        &
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_tendency( id, rs_p, rs, trs_m, ib, ic, rs_init, do_sedimentation )
+
+    USE advec_ws,                                                                                  &
+        ONLY:  advec_s_ws
+    USE advec_s_pw_mod,                                                                            &
         ONLY:  advec_s_pw
-    USE advec_s_up_mod,                                                        &
+    USE advec_s_up_mod,                                                                            &
         ONLY:  advec_s_up
-    USE arrays_3d,                                                             &
-        ONLY:  ddzu, hyp, pt, rdf_sc, tend
-    USE diffusion_s_mod,                                                       &
+    USE arrays_3d,                                                                                 &
+        ONLY:  ddzu, rdf_sc, tend
+    USE diffusion_s_mod,                                                                           &
         ONLY:  diffusion_s
-    USE indices,                                                               &
+    USE indices,                                                                                   &
         ONLY:  wall_flags_0
-    USE surface_mod,                                                           &
-        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
-                                 surf_usm_v
-    
+    USE surface_mod,                                                                               &
+        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v
+
     IMPLICIT NONE
-    
-    CHARACTER (LEN = *) ::  id
-    INTEGER(iwp) ::  b   !< bin index in derived type aerosol_size_bin    
-    INTEGER(iwp) ::  c   !< bin index in derived type aerosol_size_bin    
-    INTEGER(iwp) ::  i   !<
-    INTEGER(iwp) ::  j   !<
-    INTEGER(iwp) ::  k   !< 
-    INTEGER(iwp) ::  nc  !< (c-1)*nbins+b
-    REAL(wp), DIMENSION(nzb:nzt+1)                              ::  rs_init !<
-    REAL(wp), DIMENSION(:,:,:), POINTER                         ::  rs_p    !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER                         ::  rs      !<
-    REAL(wp), DIMENSION(:,:,:), POINTER                         ::  trs_m   !<
-    
-    nc = (c-1)*nbins+b    
+
+    CHARACTER(LEN = *) ::  id
+
+    INTEGER(iwp) ::  ib           !< loop index for aerosol number bin OR gas index
+    INTEGER(iwp) ::  ic           !< loop index for aerosol mass bin
+    INTEGER(iwp) ::  icc  !< (c-1)*nbins_aerosol+b
+    INTEGER(iwp) ::  i    !<
+    INTEGER(iwp) ::  j    !<
+    INTEGER(iwp) ::  k    !<
+
+    LOGICAL ::  do_sedimentation  !<
+
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  rs_init !<
+
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  rs_p    !<
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  rs      !<
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  trs_m   !<
+
+    icc = ( ic - 1 ) * nbins_aerosol + ib
 !
 !-- Tendency-terms for reactive scalar
     tend = 0.0_wp
-    
-    IF ( id == 'aerosol_number'  .AND.  lod_aero == 3 )  THEN
-       tend = tend + aerosol_number(b)%source
-    ELSEIF ( id == 'aerosol_mass'  .AND.  lod_aero == 3 )  THEN
-       tend = tend + aerosol_mass(nc)%source
-    ENDIF
-!    
+!
 !-- Advection terms
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
@@ -7410,67 +7416,57 @@
     ENDIF
 !
-!-- Diffusion terms    
-    IF ( id == 'aerosol_number' )  THEN
-       CALL diffusion_s(   rs,                       surf_def_h(0)%answs(:,b), &
-                           surf_def_h(1)%answs(:,b), surf_def_h(2)%answs(:,b), &
-                           surf_lsm_h%answs(:,b),    surf_usm_h%answs(:,b),    &
-                           surf_def_v(0)%answs(:,b), surf_def_v(1)%answs(:,b), &
-                           surf_def_v(2)%answs(:,b), surf_def_v(3)%answs(:,b), &
-                           surf_lsm_v(0)%answs(:,b), surf_lsm_v(1)%answs(:,b), &
-                           surf_lsm_v(2)%answs(:,b), surf_lsm_v(3)%answs(:,b), &
-                           surf_usm_v(0)%answs(:,b), surf_usm_v(1)%answs(:,b), &
-                           surf_usm_v(2)%answs(:,b), surf_usm_v(3)%answs(:,b) )                                 
-    ELSEIF ( id == 'aerosol_mass' )  THEN
-       CALL diffusion_s( rs,                        surf_def_h(0)%amsws(:,nc), & 
-                         surf_def_h(1)%amsws(:,nc), surf_def_h(2)%amsws(:,nc), &
-                         surf_lsm_h%amsws(:,nc),    surf_usm_h%amsws(:,nc),    &
-                         surf_def_v(0)%amsws(:,nc), surf_def_v(1)%amsws(:,nc), &
-                         surf_def_v(2)%amsws(:,nc), surf_def_v(3)%amsws(:,nc), &
-                         surf_lsm_v(0)%amsws(:,nc), surf_lsm_v(1)%amsws(:,nc), &
-                         surf_lsm_v(2)%amsws(:,nc), surf_lsm_v(3)%amsws(:,nc), &
-                         surf_usm_v(0)%amsws(:,nc), surf_usm_v(1)%amsws(:,nc), &
-                         surf_usm_v(2)%amsws(:,nc), surf_usm_v(3)%amsws(:,nc) )                         
-    ELSEIF ( id == 'salsa_gas' )  THEN
-       CALL diffusion_s(   rs,                       surf_def_h(0)%gtsws(:,b), &
-                           surf_def_h(1)%gtsws(:,b), surf_def_h(2)%gtsws(:,b), &
-                           surf_lsm_h%gtsws(:,b),    surf_usm_h%gtsws(:,b),    &
-                           surf_def_v(0)%gtsws(:,b), surf_def_v(1)%gtsws(:,b), &
-                           surf_def_v(2)%gtsws(:,b), surf_def_v(3)%gtsws(:,b), &
-                           surf_lsm_v(0)%gtsws(:,b), surf_lsm_v(1)%gtsws(:,b), &
-                           surf_lsm_v(2)%gtsws(:,b), surf_lsm_v(3)%gtsws(:,b), &
-                           surf_usm_v(0)%gtsws(:,b), surf_usm_v(1)%gtsws(:,b), &
-                           surf_usm_v(2)%gtsws(:,b), surf_usm_v(3)%gtsws(:,b) ) 
-    ENDIF
+!-- Diffusion terms
+    SELECT CASE ( id )
+       CASE ( 'aerosol_number' )
+          CALL diffusion_s( rs, surf_def_h(0)%answs(:,ib),                                         &
+                                surf_def_h(1)%answs(:,ib), surf_def_h(2)%answs(:,ib),              &
+                                surf_lsm_h%answs(:,ib),    surf_usm_h%answs(:,ib),                 &
+                                surf_def_v(0)%answs(:,ib), surf_def_v(1)%answs(:,ib),              &
+                                surf_def_v(2)%answs(:,ib), surf_def_v(3)%answs(:,ib),              &
+                                surf_lsm_v(0)%answs(:,ib), surf_lsm_v(1)%answs(:,ib),              &
+                                surf_lsm_v(2)%answs(:,ib), surf_lsm_v(3)%answs(:,ib),              &
+                                surf_usm_v(0)%answs(:,ib), surf_usm_v(1)%answs(:,ib),              &
+                                surf_usm_v(2)%answs(:,ib), surf_usm_v(3)%answs(:,ib) )
+       CASE ( 'aerosol_mass' )
+          CALL diffusion_s( rs, surf_def_h(0)%amsws(:,icc),                                        &
+                                surf_def_h(1)%amsws(:,icc), surf_def_h(2)%amsws(:,icc),            &
+                                surf_lsm_h%amsws(:,icc),    surf_usm_h%amsws(:,icc),               &
+                                surf_def_v(0)%amsws(:,icc), surf_def_v(1)%amsws(:,icc),            &
+                                surf_def_v(2)%amsws(:,icc), surf_def_v(3)%amsws(:,icc),            &
+                                surf_lsm_v(0)%amsws(:,icc), surf_lsm_v(1)%amsws(:,icc),            &
+                                surf_lsm_v(2)%amsws(:,icc), surf_lsm_v(3)%amsws(:,icc),            &
+                                surf_usm_v(0)%amsws(:,icc), surf_usm_v(1)%amsws(:,icc),            &
+                                surf_usm_v(2)%amsws(:,icc), surf_usm_v(3)%amsws(:,icc) )
+       CASE ( 'salsa_gas' )
+          CALL diffusion_s( rs, surf_def_h(0)%gtsws(:,ib),                                         &
+                                surf_def_h(1)%gtsws(:,ib), surf_def_h(2)%gtsws(:,ib),              &
+                                surf_lsm_h%gtsws(:,ib),    surf_usm_h%gtsws(:,ib),                 &
+                                surf_def_v(0)%gtsws(:,ib), surf_def_v(1)%gtsws(:,ib),              &
+                                surf_def_v(2)%gtsws(:,ib), surf_def_v(3)%gtsws(:,ib),              &
+                                surf_lsm_v(0)%gtsws(:,ib), surf_lsm_v(1)%gtsws(:,ib),              &
+                                surf_lsm_v(2)%gtsws(:,ib), surf_lsm_v(3)%gtsws(:,ib),              &
+                                surf_usm_v(0)%gtsws(:,ib), surf_usm_v(1)%gtsws(:,ib),              &
+                                surf_usm_v(2)%gtsws(:,ib), surf_usm_v(3)%gtsws(:,ib) )
+    END SELECT
 !
 !-- Prognostic equation for a scalar
     DO  i = nxl, nxr
        DO  j = nys, nyn
-          IF ( id == 'salsa_gas'  .AND.  lod_gases == 3 )  THEN
-             tend(:,j,i) = tend(:,j,i) + salsa_gas(b)%source(:,j,i) *          &
-                           for_ppm_to_nconc * hyp(:) / pt(:,j,i) * ( hyp(:) /  &
-                           100000.0_wp )**0.286_wp ! ppm to #/m3
-          ELSEIF ( id == 'aerosol_mass'  .OR.  id == 'aerosol_number')  THEN
-!
-!--          Sedimentation for aerosol number and mass
-             IF ( lsdepo )  THEN
-                tend(nzb+1:nzt,j,i) = tend(nzb+1:nzt,j,i) - MAX( 0.0_wp,       &
-                         ( rs(nzb+2:nzt+1,j,i) * sedim_vd(nzb+2:nzt+1,j,i,b) - &
-                           rs(nzb+1:nzt,j,i) * sedim_vd(nzb+1:nzt,j,i,b) ) *   &
-                         ddzu(nzb+1:nzt) ) * MERGE( 1.0_wp, 0.0_wp,            &
-                         BTEST( wall_flags_0(nzb:nzt-1,j,i), 0 ) )
-             ENDIF  
+!
+!--       Sedimentation for aerosol number and mass
+          IF ( lsdepo  .AND.  do_sedimentation )  THEN
+             tend(nzb+1:nzt,j,i) = tend(nzb+1:nzt,j,i) - MAX( 0.0_wp, ( rs(nzb+2:nzt+1,j,i) *      &
+                                   sedim_vd(nzb+2:nzt+1,j,i,ib) - rs(nzb+1:nzt,j,i) *              &
+                                   sedim_vd(nzb+1:nzt,j,i,ib) ) * ddzu(nzb+1:nzt) ) *              &
+                                   MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(nzb:nzt-1,j,i), 0 ) )
           ENDIF
           DO  k = nzb+1, nzt
-             rs_p(k,j,i) = rs(k,j,i) +  ( dt_3d  * ( tsc(2) * tend(k,j,i) +    &
-                                                     tsc(3) * trs_m(k,j,i) )   &
-                                                   - tsc(5) * rdf_sc(k)        &
-                                                 * ( rs(k,j,i) - rs_init(k) ) )&
-                                        * MERGE( 1.0_wp, 0.0_wp,               &
-                                          BTEST( wall_flags_0(k,j,i), 0 ) )
-             IF ( rs_p(k,j,i) < 0.0_wp )  rs_p(k,j,i) = 0.1_wp * rs(k,j,i) 
+             rs_p(k,j,i) = rs(k,j,i) +  ( dt_3d  * ( tsc(2) * tend(k,j,i) + tsc(3) * trs_m(k,j,i) )&
+                                                  - tsc(5) * rdf_sc(k) * ( rs(k,j,i) - rs_init(k) )&
+                                        ) * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+             IF ( rs_p(k,j,i) < 0.0_wp )  rs_p(k,j,i) = 0.1_wp * rs(k,j,i)
           ENDDO
        ENDDO
     ENDDO
-
 !
 !-- Calculate tendencies for the next Runge-Kutta step
@@ -7484,11 +7480,9 @@
              ENDDO
           ENDDO
-       ELSEIF ( intermediate_timestep_count < &
-                intermediate_timestep_count_max )  THEN
+       ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
           DO  i = nxl, nxr
              DO  j = nys, nyn
                 DO  k = nzb+1, nzt
-                   trs_m(k,j,i) =  -9.5625_wp * tend(k,j,i)                    &
-                                   + 5.3125_wp * trs_m(k,j,i)
+                   trs_m(k,j,i) =  -9.5625_wp * tend(k,j,i) + 5.3125_wp * trs_m(k,j,i)
                 ENDDO
              ENDDO
@@ -7496,175 +7490,216 @@
        ENDIF
     ENDIF
- 
+
  END SUBROUTINE salsa_tendency
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Boundary conditions for prognostic variables in SALSA
-!------------------------------------------------------------------------------! 
+!------------------------------------------------------------------------------!
  SUBROUTINE salsa_boundary_conds
- 
-    USE surface_mod,                                                           &
+
+    USE arrays_3d,                                                                                 &
+        ONLY:  dzu
+
+    USE surface_mod,                                                                               &
         ONLY :  bc_h
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  b  !< index for aerosol size bins    
-    INTEGER(iwp) ::  c  !< index for chemical compounds in aerosols
-    INTEGER(iwp) ::  g  !< idex for gaseous compounds
-    INTEGER(iwp) ::  i  !< grid index x direction
-    INTEGER(iwp) ::  j  !< grid index y direction
-    INTEGER(iwp) ::  k  !< grid index y direction
-    INTEGER(iwp) ::  kb !< variable to set respective boundary value, depends on
-                        !< facing.
-    INTEGER(iwp) ::  l  !< running index boundary type, for up- and downward- 
-                        !< facing walls
-    INTEGER(iwp) ::  m  !< running index surface elements
-    
-!
-!-- Surface conditions: 
-    IF ( ibc_salsa_b == 0 )  THEN   ! Dirichlet 
-!    
-!--    Run loop over all non-natural and natural walls. Note, in wall-datatype
-!--    the k coordinate belongs to the atmospheric grid point, therefore, set
-!--    s_p at k-1 
- 
-       DO  l = 0, 1
-!
-!--       Set kb, for upward-facing surfaces value at topography top (k-1) is 
-!--       set, for downward-facing surfaces at topography bottom (k+1)
-          kb = MERGE ( -1, 1, l == 0 )
-          !$OMP PARALLEL PRIVATE( b, c, g, i, j, k )
-          !$OMP DO
-          DO  m = 1, bc_h(l)%ns
-          
-             i = bc_h(l)%i(m)
-             j = bc_h(l)%j(m)
-             k = bc_h(l)%k(m)
-             
-             DO  b = 1, nbins
-                aerosol_number(b)%conc_p(k+kb,j,i) =                           &
-                                                aerosol_number(b)%conc(k+kb,j,i)
-                DO  c = 1, ncc_tot
-                   aerosol_mass((c-1)*nbins+b)%conc_p(k+kb,j,i) =              &
-                                      aerosol_mass((c-1)*nbins+b)%conc(k+kb,j,i)
+    INTEGER(iwp) ::  i    !< grid index x direction
+    INTEGER(iwp) ::  ib   !< index for aerosol size bins
+    INTEGER(iwp) ::  ic   !< index for chemical compounds in aerosols
+    INTEGER(iwp) ::  icc  !< additional index for chemical compounds in aerosols
+    INTEGER(iwp) ::  ig   !< idex for gaseous compounds
+    INTEGER(iwp) ::  j    !< grid index y direction
+    INTEGER(iwp) ::  k    !< grid index y direction
+    INTEGER(iwp) ::  kb   !< variable to set respective boundary value, depends on facing.
+    INTEGER(iwp) ::  l    !< running index boundary type, for up- and downward-facing walls
+    INTEGER(iwp) ::  m    !< running index surface elements
+
+    IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
+
+!
+!--    Surface conditions:
+       IF ( ibc_salsa_b == 0 )  THEN   ! Dirichlet
+!
+!--       Run loop over all non-natural and natural walls. Note, in wall-datatype the k coordinate 
+!--       belongs to the atmospheric grid point, therefore, set s_p at k-1
+          DO  l = 0, 1
+!
+!--          Set kb, for upward-facing surfaces value at topography top (k-1) is 
+!--          set, for downward-facing surfaces at topography bottom (k+1)
+             kb = MERGE ( -1, 1, l == 0 )
+             !$OMP PARALLEL PRIVATE( ib, ic, icc, ig, i, j, k )
+             !$OMP DO
+             DO  m = 1, bc_h(l)%ns
+
+                i = bc_h(l)%i(m)
+                j = bc_h(l)%j(m)
+                k = bc_h(l)%k(m)
+
+                DO  ib = 1, nbins_aerosol
+                   aerosol_number(ib)%conc_p(k+kb,j,i) = aerosol_number(ib)%conc(k+kb,j,i)
+                   DO  ic = 1, ncomponents_mass
+                      icc = ( ic - 1 ) * nbins_aerosol + ib
+                      aerosol_mass(icc)%conc_p(k+kb,j,i) = aerosol_mass(icc)%conc(k+kb,j,i)
+                   ENDDO
                 ENDDO
+                IF ( .NOT. salsa_gases_from_chem )  THEN
+                   DO  ig = 1, ngases_salsa
+                      salsa_gas(ig)%conc_p(k+kb,j,i) = salsa_gas(ig)%conc(k+kb,j,i)
+                   ENDDO
+                ENDIF
+
              ENDDO
-             IF ( .NOT. salsa_gases_from_chem )  THEN
-                DO  g = 1, ngast
-                   salsa_gas(g)%conc_p(k+kb,j,i) = salsa_gas(g)%conc(k+kb,j,i)
+             !$OMP END PARALLEL
+
+          ENDDO
+
+       ELSE   ! Neumann
+
+          DO l = 0, 1
+!
+!--          Set kb, for upward-facing surfaces value at topography top (k-1) is 
+!--          set, for downward-facing surfaces at topography bottom (k+1)
+             kb = MERGE( -1, 1, l == 0 )
+             !$OMP PARALLEL PRIVATE( ib, ic, icc, ig, i, j, k )
+             !$OMP DO
+             DO  m = 1, bc_h(l)%ns
+
+                i = bc_h(l)%i(m)
+                j = bc_h(l)%j(m)
+                k = bc_h(l)%k(m)
+
+                DO  ib = 1, nbins_aerosol
+                   aerosol_number(ib)%conc_p(k+kb,j,i) = aerosol_number(ib)%conc_p(k,j,i)
+                   DO  ic = 1, ncomponents_mass
+                      icc = ( ic - 1 ) * nbins_aerosol + ib
+                      aerosol_mass(icc)%conc_p(k+kb,j,i) = aerosol_mass(icc)%conc_p(k,j,i)
+                   ENDDO
                 ENDDO
-             ENDIF
-             
+                IF ( .NOT. salsa_gases_from_chem ) THEN
+                   DO  ig = 1, ngases_salsa
+                      salsa_gas(ig)%conc_p(k+kb,j,i) = salsa_gas(ig)%conc_p(k,j,i)
+                   ENDDO
+                ENDIF
+
+             ENDDO
+             !$OMP END PARALLEL
           ENDDO
-          !$OMP END PARALLEL
-          
-       ENDDO
-    
-    ELSE   ! Neumann
-    
-       DO l = 0, 1
-!
-!--       Set kb, for upward-facing surfaces value at topography top (k-1) is 
-!--       set, for downward-facing surfaces at topography bottom (k+1)       
-          kb = MERGE( -1, 1, l == 0 )
-          !$OMP PARALLEL PRIVATE( b, c, g, i, j, k )
-          !$OMP DO
-          DO  m = 1, bc_h(l)%ns
-             
-             i = bc_h(l)%i(m)
-             j = bc_h(l)%j(m)
-             k = bc_h(l)%k(m)
-             
-             DO  b = 1, nbins
-                aerosol_number(b)%conc_p(k+kb,j,i) =                           &
-                                                 aerosol_number(b)%conc_p(k,j,i)
-                DO  c = 1, ncc_tot
-                   aerosol_mass((c-1)*nbins+b)%conc_p(k+kb,j,i) =              &
-                                       aerosol_mass((c-1)*nbins+b)%conc_p(k,j,i)
-                ENDDO
+
+       ENDIF
+!
+!--   Top boundary conditions:
+       IF ( ibc_salsa_t == 0 )  THEN   ! Dirichlet
+
+          DO  ib = 1, nbins_aerosol
+             aerosol_number(ib)%conc_p(nzt+1,:,:) = aerosol_number(ib)%conc(nzt+1,:,:)
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                aerosol_mass(icc)%conc_p(nzt+1,:,:) = aerosol_mass(icc)%conc(nzt+1,:,:)
              ENDDO
-             IF ( .NOT. salsa_gases_from_chem ) THEN
-                DO  g = 1, ngast
-                   salsa_gas(g)%conc_p(k+kb,j,i) = salsa_gas(g)%conc_p(k,j,i)
-                ENDDO
-             ENDIF
-                
           ENDDO
-          !$OMP END PARALLEL
-       ENDDO
-     
-    ENDIF
-
-!
-!--Top boundary conditions:
-    IF ( ibc_salsa_t == 0 )  THEN   ! Dirichlet 
-   
-       DO  b = 1, nbins
-          aerosol_number(b)%conc_p(nzt+1,:,:) =                                &
-                                               aerosol_number(b)%conc(nzt+1,:,:)
-          DO  c = 1, ncc_tot
-             aerosol_mass((c-1)*nbins+b)%conc_p(nzt+1,:,:) =                   &
-                                     aerosol_mass((c-1)*nbins+b)%conc(nzt+1,:,:)
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc_p(nzt+1,:,:) = salsa_gas(ig)%conc(nzt+1,:,:)
+             ENDDO
+          ENDIF
+
+       ELSEIF ( ibc_salsa_t == 1 )  THEN   ! Neumann
+
+          DO  ib = 1, nbins_aerosol
+             aerosol_number(ib)%conc_p(nzt+1,:,:) = aerosol_number(ib)%conc_p(nzt,:,:)
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                aerosol_mass(icc)%conc_p(nzt+1,:,:) = aerosol_mass(icc)%conc_p(nzt,:,:)
+             ENDDO
           ENDDO
-       ENDDO
-       IF ( .NOT. salsa_gases_from_chem )  THEN
-          DO  g = 1, ngast
-             salsa_gas(g)%conc_p(nzt+1,:,:) = salsa_gas(g)%conc(nzt+1,:,:)
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc_p(nzt+1,:,:) = salsa_gas(ig)%conc_p(nzt,:,:)
+             ENDDO
+          ENDIF
+
+       ELSEIF ( ibc_salsa_t == 2 )  THEN   ! nested
+
+          DO  ib = 1, nbins_aerosol
+             aerosol_number(ib)%conc_p(nzt+1,:,:) = aerosol_number(ib)%conc_p(nzt,:,:) +              &
+                                                    bc_an_t_val(ib) * dzu(nzt+1)
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                aerosol_mass(icc)%conc_p(nzt+1,:,:) = aerosol_mass(icc)%conc_p(nzt,:,:) +             &
+                                                      bc_am_t_val(icc) * dzu(nzt+1)
+             ENDDO
           ENDDO
-       ENDIF
-       
-    ELSEIF ( ibc_salsa_t == 1 )  THEN   ! Neumann 
-    
-       DO  b = 1, nbins
-          aerosol_number(b)%conc_p(nzt+1,:,:) =                                &
-                                               aerosol_number(b)%conc_p(nzt,:,:)
-          DO  c = 1, ncc_tot
-             aerosol_mass((c-1)*nbins+b)%conc_p(nzt+1,:,:) =                   &
-                                     aerosol_mass((c-1)*nbins+b)%conc_p(nzt,:,:)
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc_p(nzt+1,:,:) = salsa_gas(ig)%conc_p(nzt,:,:) +                     &
+                                                  bc_gt_t_val(ig) * dzu(nzt+1)
+             ENDDO
+          ENDIF
+
+       ENDIF
+!
+!--    Lateral boundary conditions at the outflow
+       IF ( bc_radiation_s )  THEN
+          DO  ib = 1, nbins_aerosol
+             aerosol_number(ib)%conc_p(:,nys-1,:) = aerosol_number(ib)%conc_p(:,nys,:)
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                aerosol_mass(icc)%conc_p(:,nys-1,:) = aerosol_mass(icc)%conc_p(:,nys,:)
+             ENDDO
           ENDDO
-       ENDDO
-       IF ( .NOT. salsa_gases_from_chem )  THEN
-          DO  g = 1, ngast
-             salsa_gas(g)%conc_p(nzt+1,:,:) = salsa_gas(g)%conc_p(nzt,:,:)
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc_p(:,nys-1,:) = salsa_gas(ig)%conc_p(:,nys,:)
+             ENDDO
+          ENDIF
+
+       ELSEIF ( bc_radiation_n )  THEN
+          DO  ib = 1, nbins_aerosol
+             aerosol_number(ib)%conc_p(:,nyn+1,:) = aerosol_number(ib)%conc_p(:,nyn,:)
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                aerosol_mass(icc)%conc_p(:,nyn+1,:) = aerosol_mass(icc)%conc_p(:,nyn,:)
+             ENDDO
           ENDDO
-       ENDIF
-       
-    ENDIF
-!
-!-- Lateral boundary conditions at the outflow    
-    IF ( bc_radiation_s )  THEN
-       DO  b = 1, nbins
-          aerosol_number(b)%conc_p(:,nys-1,:) = aerosol_number(b)%conc_p(:,nys,:)
-          DO  c = 1, ncc_tot
-             aerosol_mass((c-1)*nbins+b)%conc_p(:,nys-1,:) =                   &
-                                     aerosol_mass((c-1)*nbins+b)%conc_p(:,nys,:)
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc_p(:,nyn+1,:) = salsa_gas(ig)%conc_p(:,nyn,:)
+             ENDDO
+          ENDIF
+
+       ELSEIF ( bc_radiation_l )  THEN
+          DO  ib = 1, nbins_aerosol
+             aerosol_number(ib)%conc_p(:,:,nxl-1) = aerosol_number(ib)%conc_p(:,:,nxl)
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                aerosol_mass(icc)%conc_p(:,:,nxl-1) = aerosol_mass(icc)%conc_p(:,:,nxl)
+             ENDDO
           ENDDO
-       ENDDO
-    ELSEIF ( bc_radiation_n )  THEN
-       DO  b = 1, nbins
-          aerosol_number(b)%conc_p(:,nyn+1,:) = aerosol_number(b)%conc_p(:,nyn,:)
-          DO  c = 1, ncc_tot
-             aerosol_mass((c-1)*nbins+b)%conc_p(:,nyn+1,:) =                   &
-                                     aerosol_mass((c-1)*nbins+b)%conc_p(:,nyn,:)
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc_p(:,:,nxl-1) = salsa_gas(ig)%conc_p(:,:,nxl)
+             ENDDO
+          ENDIF
+
+       ELSEIF ( bc_radiation_r )  THEN
+          DO  ib = 1, nbins_aerosol
+             aerosol_number(ib)%conc_p(:,:,nxr+1) = aerosol_number(ib)%conc_p(:,:,nxr)
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                aerosol_mass(icc)%conc_p(:,:,nxr+1) = aerosol_mass(icc)%conc_p(:,:,nxr)
+             ENDDO
           ENDDO
-       ENDDO
-    ELSEIF ( bc_radiation_l )  THEN
-       DO  b = 1, nbins
-          aerosol_number(b)%conc_p(:,nxl-1,:) = aerosol_number(b)%conc_p(:,nxl,:)
-          DO  c = 1, ncc_tot
-             aerosol_mass((c-1)*nbins+b)%conc_p(:,nxl-1,:) =                   &
-                                     aerosol_mass((c-1)*nbins+b)%conc_p(:,nxl,:)
-          ENDDO
-       ENDDO
-    ELSEIF ( bc_radiation_r )  THEN
-       DO  b = 1, nbins
-          aerosol_number(b)%conc_p(:,nxr+1,:) = aerosol_number(b)%conc_p(:,nxr,:)
-          DO  c = 1, ncc_tot
-             aerosol_mass((c-1)*nbins+b)%conc_p(:,nxr+1,:) =                   &
-                                     aerosol_mass((c-1)*nbins+b)%conc_p(:,nxr,:)
-          ENDDO
-       ENDDO
+          IF ( .NOT. salsa_gases_from_chem )  THEN
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc_p(:,:,nxr+1) = salsa_gas(ig)%conc_p(:,:,nxr)
+             ENDDO
+          ENDIF
+
+       ENDIF
+
     ENDIF
 
@@ -7675,19 +7710,22 @@
 ! ------------
 ! Undoing of the previously done cyclic boundary conditions.
-!------------------------------------------------------------------------------! 
+!------------------------------------------------------------------------------!
  SUBROUTINE salsa_boundary_conds_decycle ( sq, sq_init )
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  boundary !< 
-    INTEGER(iwp) ::  ee !<
-    INTEGER(iwp) ::  copied !< 
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-    INTEGER(iwp) ::  ss !<
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  sq_init
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sq
-    REAL(wp) ::  flag !< flag to mask topography grid points
+    INTEGER(iwp) ::  boundary  !<
+    INTEGER(iwp) ::  ee        !<
+    INTEGER(iwp) ::  copied    !<
+    INTEGER(iwp) ::  i         !<
+    INTEGER(iwp) ::  j         !<
+    INTEGER(iwp) ::  k         !<
+    INTEGER(iwp) ::  ss        !<
+
+    REAL(wp) ::  flag  !< flag to mask topography grid points
+
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  sq_init  !< initial concentration profile
+
+    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sq  !< concentration array
 
     flag = 0.0_wp
@@ -7695,10 +7733,10 @@
 !-- Left and right boundaries
     IF ( decycle_lr  .AND.  ( bc_lr_cyc  .OR. bc_lr == 'nested' ) )  THEN
-    
+
        DO  boundary = 1, 2
 
           IF ( decycle_method(boundary) == 'dirichlet' )  THEN
-!    
-!--          Initial profile is copied to ghost and first three layers          
+!
+!--          Initial profile is copied to ghost and first three layers
              ss = 1
              ee = 0
@@ -7710,19 +7748,18 @@
                 ee = nxrg
              ENDIF
-             
+
              DO  i = ss, ee
                 DO  j = nysg, nyng
-                   DO  k = nzb+1, nzt             
-                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
-                                    BTEST( wall_flags_0(k,j,i), 0 ) )
+                   DO  k = nzb+1, nzt
+                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
                       sq(k,j,i) = sq_init(k) * flag
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           ELSEIF ( decycle_method(boundary) == 'neumann' )  THEN
 !
-!--          The value at the boundary is copied to the ghost layers to simulate
-!--          an outlet with zero gradient
+!--          The value at the boundary is copied to the ghost layers to simulate an outlet with
+!--          zero gradient
              ss = 1
              ee = 0
